﻿fileObj = new File(File.openDialog("タブ区切りテキストファイルを指定してください"));
TAB = String.fromCharCode(9);	// タブコード

//ダイアログで数値を設定
var myDiag=app.dialogs.add({name:"体裁に関する設定"});
with (myDiag.dialogColumns.add()) {

with (borderPanels.add()){
staticTexts.add({staticLabel:"【1】最大目盛り：", minWidth:80});
var maxVal=realEditboxes.add({editValue:200, minWidth:80});
staticTexts.add({staticLabel:"※充分に大きな値にすること"});
}
/*
with (borderPanels.add()){
staticTexts.add({staticLabel:"【2】最小目盛り：", minWidth:80});
var minVal=realEditboxes.add({editValue:0, minWidth:80});
staticTexts.add({staticLabel:"※基本は「0」"});
}
*/
with (borderPanels.add()){
staticTexts.add({staticLabel:"【2】換算率：数値"});
var cnvVal=realEditboxes.add({editValue:100, minWidth:80});
staticTexts.add({staticLabel:"をグラフ上で幅"});
var cnvMm=realEditboxes.add({editValue:50, minWidth:80});
staticTexts.add({staticLabel:"mmにする。"});
}

with (borderPanels.add()){
staticTexts.add({staticLabel:"【3】棒の幅（mm）："});
var boWdth=realEditboxes.add({editValue:10, minWidth:80});
staticTexts.add({staticLabel:"mm"});
}

with (borderPanels.add()){
staticTexts.add({staticLabel:"【4】棒と棒の間隔（mm）："});
var intvl=realEditboxes.add({editValue:8, minWidth:80});
staticTexts.add({staticLabel:"mm"});
}
}
myDiag.show();
maxVal=maxVal.editValue;	//【1】
//minVal=minVal.editValue;
minVal=0;   //最小値はゼロに固定した。
cnv=cnvMm.editValue/cnvVal.editValue;	//【2】
boWdth=boWdth.editValue;	//【3】
intvl=intvl.editValue;	//【4】

//ここからドキュメント作成と基本設定
flagA = fileObj.open("r");
if (flagA)
{
countA = 0;	//行数をカウント
while(!fileObj.eof)
{
textA = fileObj.readln();	//　１行読み込む
txtItemA = textA.split(TAB);	//　タブコードで行を列ごとに分割
countA++;
}
fileObj.close();	//いったん閉じる

mgnTp = 12 ;	//上アキ（凡例と見出し用スペース／アキ5mm+凡例長方形3mm+隙間1mm+TF3mm）
mgnBtm = 10 ;	//下アキ（X座標の文字用スペース／隙間2mm＋TF3mm+アキ5mm）
mgnLeft = 30  ;	//左アキ（Y座標の文字用スペース／アキ5mm+TF24mm+隙間1mm）
mgnRight = 5+16*(txtItemA.length-1)+2*(txtItemA.length-2)+5 ;	//右アキ（数値用スペース／5mm＋TF16mm*TF数+隙間2mm*隙間数+アキ5mm）
gHight = intvl/2+boWdth*(countA-1)+intvl*(countA-2)+intvl/2 ;	//グラフ領域の高さ（intvlの半分＋棒*グラフ数+intvl/隙間数+intvlの半分）
gWidth = (maxVal-minVal)*cnv;	//グラフ領域の幅
ttlHight = mgnTp+gHight+mgnBtm;
ttlWidth = mgnLeft+gWidth+mgnRight;

myDoc = app.documents.add();
myDoc.documentPreferences.pageWidth = ttlWidth;
myDoc.documentPreferences.pageHeight = ttlHight;
myDoc.documentPreferences.facingPages=false; //見開きオフ
myDoc.documentPreferences.pageBinding = PageBindingOptions.leftToRight;//左から右
app.activeDocument.pages[0].marginPreferences.top=0;//マージン上
app.activeDocument.pages[0].marginPreferences.bottom=0;//マージン下
app.activeDocument.pages[0].marginPreferences.left=0;//マージン左
app.activeDocument.pages[0].marginPreferences.right=0;//マージン右
app.activeDocument.pages[0].marginPreferences.columnDirection = HorizontalOrVertical.horizontal;//文字組み方向-横
//ベースレイヤーの名称指定
app.activeDocument.layers[0].name="base";
//テキストレイヤーを追加
lay02=app.activeDocument.layers.add();
lay02.name="text";
//グラフレイヤーを追加
lay03=app.activeDocument.layers.add(); //レイヤーを追加
lay03.name="graph";  //レイヤー命名
//区分線レイヤーを追加
lay04=app.activeDocument.layers.add(); //レイヤーを追加
lay04.name="kubun_line";  //レイヤー命名

//段落スタイルを追加
app.documents[0].paragraphStyleGroups.add({name:"graph"});	//段落スタイルグループ
var numScalePrSt=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.add({name:"numScale"});	//下部・数値目盛りの段落スタイル
numScalePrSt.pointSize = "10Q";
numScalePrSt.justification=1667591796; //中央揃え

var btmScalePrSt=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.add({name:"leftScale"});	//左側・目盛りの段落スタイル
btmScalePrSt.pointSize = "10Q";
btmScalePrSt.justification=1919379572; //右揃え

var valPrSt=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.add({name:"value"});	//数値の段落スタイル
valPrSt.pointSize = "10Q";
valPrSt.justification=1919379572; //右揃え

var valPrSt=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.add({name:"index"});	//見出しの段落スタイル
valPrSt.pointSize = "12Q";
valPrSt.justification=1667591796; //中央揃え
}
for( a = 1 ; a<txtItemA.length ; a++){
//スウォッチを作成
app.activeDocument.colors.add({name:"gColor"+a , model:ColorModel.process,space:ColorSpace.cmyk,colorValue:[0, 0, 0, 60]});//スウォッチ
//文字スタイルを追加
var newChrctSt=app.documents[0].characterStyles.add({name:"Graph-"+a });	//文字スタイル
newChrctSt.fillColor = app.documents[0].swatches.itemByName("gColor"+a ); 
}

//X軸を作成
lnX = app.activeDocument.rectangles.add();
lnX.paths.item(0).entirePath = [[mgnLeft,mgnTp+gHight],[mgnLeft+gWidth,mgnTp+gHight]];
lnX.paths.item(0).pathType = PathType.openPath;
lnX.strokeWeight =0.25;
lnX.endCap=1919115632;    //丸形線端
lnX.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

//X軸左端の線を作成
lnXlt = app.activeDocument.rectangles.add();
lnXlt.paths.item(0).entirePath = [[mgnLeft,mgnTp+gHight],[mgnLeft,mgnTp+gHight+1]];
lnXlt.paths.item(0).pathType = PathType.openPath;
lnXlt.strokeWeight =0.25;
lnXlt.endCap=1919115632;    //丸形線端
lnXlt.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

//X軸右端の線を作成
lnXrt = app.activeDocument.rectangles.add();
lnXrt.paths.item(0).entirePath = [[mgnLeft+gWidth,mgnTp+gHight],[mgnLeft+gWidth,mgnTp+gHight+1]];
lnXrt.paths.item(0).pathType = PathType.openPath;
lnXrt.strokeWeight =0.25;
lnXrt.endCap=1919115632;    //丸形線端
lnXrt.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

//最小値（=0）を作成
txtObjMin = app.activeDocument.textFrames.add();
txtObjMin.visibleBounds = [mgnTp+gHight+2,mgnLeft-2,mgnTp+gHight+5,mgnLeft+1];//上辺, 左辺, 下辺, 右辺
txtObjMin.contentType = ContentType.textType;
txtObjMin.contents = minVal+"" ;    //文字列に変換した上で
txtObjMin.textFramePreferences.verticalJustification = VerticalJustification.centerAlign;
txtObjMin.paragraphs[0].appliedParagraphStyle=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.itemByName("numScale");
txtObjMin.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

//最大値を作成
txtObjMax = app.activeDocument.textFrames.add();
txtObjMax.visibleBounds = [mgnTp+gHight+2,mgnLeft+gWidth-8,mgnTp+gHight+5,mgnLeft+gWidth+8];//上辺, 左辺, 下辺, 右辺
txtObjMax.contentType = ContentType.textType;
txtObjMax.contents = maxVal+"" ;    //文字列に変換した上で
txtObjMax.textFramePreferences.verticalJustification = VerticalJustification.centerAlign;
txtObjMax.paragraphs[0].appliedParagraphStyle=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.itemByName("numScale");
txtObjMax.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

//Y軸を作成
lnY = app.activeDocument.rectangles.add();
lnY.paths.item(0).entirePath = [[mgnLeft,mgnTp],[mgnLeft,mgnTp+gHight]];
lnY.paths.item(0).pathType = PathType.openPath;
lnY.strokeWeight =0.25;
lnY.endCap=1919115632;    //丸形線端
lnY.move(app.documents[0].layers[app.activeDocument.layers.length-1]);

//Y軸上の区切り線を作成
for( b=0 ; b<countA-1 ; b++ ){
lnLt = app.activeDocument.rectangles.add();
lnLt.paths.item(0).entirePath = [[mgnLeft,mgnTp+(boWdth+intvl)*b],[mgnLeft+1,mgnTp+(boWdth+intvl)*b]];
lnLt.paths.item(0).pathType = PathType.openPath;
lnLt.strokeWeight =0.25;
lnLt.endCap=1919115632;    //丸形線端
lnLt.move(app.documents[0].layers[app.activeDocument.layers.length-1]);
}

//Y軸の文字を作成
flagB = fileObj.open("r");
if (flagB)
{
countB = 0;
while(!fileObj.eof)
{
textB = fileObj.readln();	//　１行読み込む
txtItemB = textB.split(TAB);	//　タブコードで分割
if(countB != 0){
//Y軸の文字を作成
txtObjLt = app.activeDocument.textFrames.add();
txtObjLt.contentType = ContentType.textType;
txtObjLt.contents = txtItemB[0];
txtObjLt.visibleBounds = [mgnTp+intvl/2+(boWdth+intvl)*(countB-1) , 5 ,mgnTp+intvl/2+boWdth*countB+intvl*(countB-1),29];//上辺, 左辺, 下辺, 右辺
txtObjLt.textFramePreferences.verticalJustification = VerticalJustification.centerAlign;	//中央に
txtObjLt.paragraphs[0].appliedParagraphStyle=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.itemByName("leftScale");
txtObjLt.move(app.documents[0].layers[app.activeDocument.layers.length-1]);
}
countB++;
}
}
fileObj.close();	//いったん閉じる

//凡例、見出し、数値を作成
flagC = fileObj.open("r");
if (flagC)
{
countC = 0;
while(!fileObj.eof)
{
textC = fileObj.readln();	//　１行読み込む
txtItemC = textC.split(TAB);	//　タブコードで分割
for( c=1 ; c<txtItemC.length ; c++ ){
var lt = mgnLeft+gWidth+5+18*(c-1);
if(countC==0){
//凡例長方形
hnrRct = app.activeDocument.rectangles.add();
hnrRct.geometricBounds =[5,lt,8,lt+16];	//上辺, 左辺, 下辺, 右辺
hnrRct.strokeWeight =0;
hnrRct.fillColor=app.activeDocument.swatches.itemByName("gColor"+c);
hnrRct.strokeColor=app.activeDocument.swatches.itemByName("None");
hnrRct.move(app.documents[0].layers[app.activeDocument.layers.length-2]);
//見出し
txtObjIndex = app.activeDocument.textFrames.add();
txtObjIndex.geometricBounds =[9,lt,12,lt+16];	//上辺, 左辺, 下辺, 右辺
txtObjIndex.contentType = ContentType.textType;
txtObjIndex.contents = txtItemC[c];
txtObjIndex.textFramePreferences.verticalJustification = VerticalJustification.centerAlign;	//中央に
txtObjIndex.paragraphs[0].appliedParagraphStyle=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.itemByName("index");
txtObjIndex.paragraphs[0].appliedCharacterStyle=app.documents[0].characterStyles.itemByName("Graph-"+c);
txtObjIndex.move(app.documents[0].layers[app.activeDocument.layers.length-2]);
}else{
//数値
txtObjVal = app.activeDocument.textFrames.add();
txtObjVal.geometricBounds =[mgnTp+intvl/2+(boWdth+intvl)*(countC-1),lt,mgnTp+intvl/2+boWdth*countC+intvl*(countC-1),lt+16];	//上辺, 左辺, 下辺, 右辺
txtObjVal.contentType = ContentType.textType;
txtObjVal.contents = txtItemC[c];
txtObjVal.textFramePreferences.verticalJustification = VerticalJustification.centerAlign;	//中央に
txtObjVal.paragraphs[0].appliedParagraphStyle=app.documents[0].paragraphStyleGroups.itemByName("graph").paragraphStyles.itemByName("value");
txtObjVal.paragraphs[0].appliedCharacterStyle=app.documents[0].characterStyles.itemByName("Graph-"+c);
txtObjVal.move(app.documents[0].layers[app.activeDocument.layers.length-2]);
}
}
countC++;
}
}
fileObj.close();	//いったん閉じる

//グラフ棒の作成
flagD = fileObj.open("r");
if (flagD)
{
countD = 0;
while(!fileObj.eof)
{
textD = fileObj.readln();	//　１行読み込む
txtItemD = textD.split(TAB);	//　タブコードで分割
if(countD==0){	//0行目は何もしない
}else{
var glt = mgnLeft	//最初の左端座標
for( d=1 ; d<txtItemD.length ; d++ ){
var grt = glt+txtItemD[d]*cnv;
var gtp = mgnTp+intvl/2+(boWdth+intvl)*(countD-1);
var gbm = gtp+boWdth;
if(txtItemD[d] != 0){
newGraph = app.activeDocument.rectangles.add();
newGraph.geometricBounds =[gtp,glt,gbm,grt];//上辺, 左辺, 下辺, 右辺
newGraph.strokeWeight =0;
newGraph.fillColor=app.activeDocument.swatches.itemByName("gColor"+d);
newGraph.strokeColor=app.activeDocument.swatches.itemByName("None");
newGraph.move(app.documents[0].layers[app.activeDocument.layers.length-3]);
}
glt = grt	//次の左辺座標は現在の右辺座標を使用するので代入
}
}
countD++;
}
}
fileObj.close();	//いったん閉じる

//区分線の作成
flagE = fileObj.open("r");
if (flagE)
{
countE = 0;
while(!fileObj.eof)
{
textE = fileObj.readln();	//　１行読み込む
txtItemE = textE.split(TAB);	//　タブコードで分割
if(countE==0){	//0行目は何もしない
}else if(countE==1){	//1行目は配列gAry1を用意して値をpushするだけ
var gAry1 = [0];	//配列を用意。0番目の値は「0」とする。
for( ea=1 ; ea<txtItemE.length ; ea++ ){
var gVal1 = Number(txtItemE[ea]);
gAry1.push(gAry1[ea-1]+gVal1);	//各値を累積してpush。
//alert(gAry1[ea]);		//確認
}
}else{	//2行目以降で区分線作成
var gAry2 = [0];	//配列gAry2を用意。0番目の値は「0」とする。
for( eb=1 ; eb<txtItemE.length ; eb++ ){
var gVal2 = Number(txtItemE[eb]);
gAry2.push(gAry2[eb-1]+gVal2);	//各値を累積してpush。

var x1 = mgnLeft + gAry1[eb]*cnv;
var y1 = mgnTp+intvl/2+(boWdth+intvl)*(countE-1)-intvl;
var x2 = mgnLeft + gAry2[eb]*cnv;
var y2 = y1+intvl;

kbnLn = app.activeDocument.rectangles.add();
kbnLn.paths.item(0).entirePath = [[x1,y1],[x2,y2]];
kbnLn.paths.item(0).pathType = PathType.openPath;
kbnLn.strokeWeight =0.1;
kbnLn.endCap=1919115632;    //丸形線端
kbnLn.move(app.documents[0].layers[0]);

gAry1[eb] = gAry2[eb];	//次のためにgAry1の値に代入。
}
}
countE++;
}
}
fileObj.close();	//いったん閉じる

//ベースレイヤー（この時点では最背面）を最前面に移動
app.documents[0].layers[app.activeDocument.layers.length-1].move(LocationOptions.atBeginning);
//テキストレイヤー（この時点では最背面）を最前面に移動
app.documents[0].layers[app.activeDocument.layers.length-1].move(LocationOptions.atBeginning);